set ns [new Simulator]
$ns set cosim_type 0

#### Open files for statistics #####
set traceFile [open diffserv.tr w]
$ns trace-all $traceFile
set namFile [open diffserv.nam w]
$ns namtrace-all $namFile

proc finish {} {
	global ns
	global namFile
	global traceFile
	$ns flush-trace
	close $namFile
	close $traceFile
	exit 0
}

set node0 [$ns node]
set node1 [$ns node]
set node2 [$ns node]
set node3 [$ns node]
set node4 [$ns node]
set node5 [$ns node]
set edge [$ns node]

$ns duplex-link $node0 $edge 10Mb 10ms DropTail
$ns duplex-link $node1 $edge 10Mb 10ms DropTail

$ns simplex-link $edge $node2 10Mb 10ms dsRED/edge
$ns simplex-link $node2 $edge 10Mb 10ms dsRED/core
# bottleneck link
$ns simplex-link $node2 $node3 100kb 20ms dsRED/core
$ns simplex-link $node3 $node2 100kb 20ms dsRED/edge

$ns simplex-link $node3 $node4 10Mb 10ms DropTail
$ns simplex-link $node3 $node5 10Mb 10ms DropTail

set qe2 [[$ns link $edge $node2] queue]
$qe2 meanPktSize 400
$qe2 set numQueues_ 2
$qe2 setNumPrec 1
$qe2 addPolicyEntry [$node0 id] [$node4 id] Null 11
$qe2 addPolicyEntry [$node1 id] [$node5 id] Null 00
$qe2 addPolicerEntry Null 11
$qe2 addPolicerEntry Null 00
$qe2 addPHBEntry 00 0 0
$qe2 addPHBEntry 11 1 0
$qe2 configQ 0 0 20 40 0.02
$qe2 configQ 1 0 10 20 0.10
$qe2 printPolicyTable
$qe2 printPolicerTable

set q23 [[$ns link $node2 $node3] queue]
$q23 meanPktSize 400
$q23 set numQueues_ 2
$q23 setNumPrec 1
$q23 setSchedularMode WRR
$q23 addQueueWeights 0 5
$q23 addQueueWeights 1 5
$q23 addPHBEntry 00 0 0
$q23 addPHBEntry 11 1 0
$q23 configQ 0 0 20 40 0.02
$q23 configQ 1 0 10 20 0.10

set q32 [[$ns link $node3 $node2] queue]
$q32 meanPktSize 400
$q32 set numQueues_ 2
$q32 setNumPrec 1
$q32 addPolicyEntry [$node4 id] [$node0 id] Null 11
$q32 addPolicyEntry [$node5 id] [$node1 id] Null 00
$q32 addPolicerEntry Null 11
$q32 addPolicerEntry Null 00
$q32 addPHBEntry 00 0 0
$q32 addPHBEntry 11 1 0
$q32 configQ 0 0 20 40 0.02
$q32 configQ 1 0 10 20 0.10

set q2e [[$ns link $node2 $edge] queue]
$q2e meanPktSize 400
$q2e set numQueues_ 2
$q2e setNumPrec 1
$q2e addPHBEntry 00 0 0
$q2e addPHBEntry 11 1 0
$q2e configQ 0 0 20 40 0.02
$q2e configQ 1 0 10 20 0.10

# CBR 0
# on Ethernet the max IP packet size is 1500 byte
# CBR 0
# on Ethernet the max IP packet size is 1500 byte
set udp0 [new Agent/UDP]
$udp0 set packetSize_ 1500
$udp0 set fid_ 1000
set null0 [new Agent/Null]

$ns attach-agent $node0 $udp0
$ns attach-agent $node4 $null0
$ns connect $udp0 $null0

set cbr0 [new Application/Traffic/CBR]
$cbr0 set packetSize_ 400
$cbr0 set interval_ 0.040
$cbr0 attach-agent $udp0

# CBR 1
# on Ethernet the max IP packet size is 1500 byte
set udp1 [new Agent/UDP]
$udp1 set packetSize_ 1500
$udp1 set fid_ 2000
set null1 [new Agent/Null]

$ns attach-agent $node1 $udp1
$ns attach-agent $node5 $null1
$ns connect $udp1 $null1

set cbr1 [new Application/Traffic/CBR]
$cbr1 set packetSize_ 400
$cbr1 set interval_ 0.040
$cbr1 attach-agent $udp1

$ns at 1.0 "$cbr0 start"
$ns at 1.0 "$cbr1 start" 
$ns at 210.0 "$cbr0 stop"
$ns at 210.0 "$cbr1 stop" 
$ns at 300.0 "finish"
$ns run

